﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.TreeListView;
using Telerik.Windows.Controls;
using System.ComponentModel;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var collection = new ObservableCollection<MyObject>(from i in Enumerable.Range(0, 1000)
                                                                select new MyObject()
                                                                {
                                                                    ID = i,
                                                                    Name = string.Format("Name{0}", i),
                                                                });

            DataContext = collection;
        }

        private void RadTreeListView_RowLoaded(object sender, Telerik.Windows.Controls.GridView.RowLoadedEventArgs e)
        {
            var row = e.Row as TreeListViewRow;
            if (row != null)
            {
                row.IsExpandable = true;
            }
        }

        private void RadTreeListView_RowIsExpandedChanged(object sender, Telerik.Windows.Controls.GridView.RowEventArgs e)
        {
            var row = e.Row as TreeListViewRow;
            if (row != null)
            {
                var obj = e.Row.DataContext as MyObject;

                if (row.IsExpanded && obj.Items == null)
                {
                    obj.Items = new ObservableCollection<MyObject>(from i in Enumerable.Range(0, 1000)
                                                                   select new MyObject()
                                                                   {
                                                                       ID = i,
                                                                       Name = string.Format("Name{0}", i)
                                                                   });
                }
            }
        }
    }

    public class MyObject : ViewModelBase
    {
        public int ID { get; set; }
        public string Name { get; set; }

        public ObservableCollection<MyObject> _Items;

        [Browsable(false)]
        public ObservableCollection<MyObject> Items
        {
            get
            {
                return _Items;
            }
            set
            {
                if (_Items != value)
                {
                    _Items = value;

                    OnPropertyChanged("Items");
                }
            }
        }
    }
}
